from pathlib import Path
from typing import Optional

from lmm.const import LMM_GAMES_PATH

class Profile:
    # The name of the game.
    game: str

    # The name of the profile.
    name: str

    # The runner to use for the profile.
    runner: Optional["Runner"]

    def __init__(self, game: str, name: str, runner: Optional["Runner"]):
        self.game = game
        self.name = name
        self.runner = runner

    def get_mod_names(self) -> list[str]:
        raise NotImplementedError()